
#include "Bob.h"

void ABob::BeginPlay()
{
	Super::BeginPlay();

	if (HasAuthority())
	{
		// We wait a little bit to ensure the client's copy of this actor begins play as well
		FTimerHandle Handle;
		GetWorld()->GetTimerManager().SetTimer(Handle, this, &ABob::AddBobComponent, 2.f);
	}
}

void ABob::AddBobComponent()
{
	// (Server) Add the replicated component
	auto Co = NewObject<UBobComponent>(this);
	Co->RegisterComponent();
}

UBobComponent::UBobComponent()
{
	bReplicates = true;
}

void UBobComponent::BeginPlay()
{
	Super::BeginPlay();

	if (auto PC = Cast<APlayerController>(GetOwner()))
	{
		if (PC->IsLocalController())
		{
			// Calling a RPC right now won't work (in clients) since the NetGUID was not registered yet.
			ServerRPC();

			// But calling it next tick will.
			//GetWorld()->GetTimerManager().SetTimerForNextTick(this, &UBobComponent::ServerRPC);
		}
	}
}

bool UBobComponent::ServerRPC_Validate()
{
	return true;
}

void UBobComponent::ServerRPC_Implementation()
{
	UE_LOG(LogTemp, Display, TEXT("OK."));
}
